SystemOrganization addCategory: #'Seaside-RenderLoop'!

WAObject subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoop methodsFor: 'processing' stamp: 'lr 3/29/2008 14:20'!
call: aComponent 
	^ WAContinuation currentDo: [ :cc | 
		aComponent onAnswer: cc.
		self root: aComponent.
		self run ]! !

!WARenderLoop methodsFor: 'accessing-properties' stamp: 'lr 8/17/2007 09:56'!
renderContinuationClass
	^ self application preferenceAt: #renderContinuationClass! !

!WARenderLoop methodsFor: 'accessing' stamp: 'lr 4/20/2007 15:12'!
root
	^ root! !

!WARenderLoop methodsFor: 'accessing' stamp: 'jf 9/13/2008 09:53'!
root: aComponent
	root := aComponent! !

!WARenderLoop methodsFor: 'processing' stamp: 'lr 8/17/2007 09:54'!
run
	(self renderContinuationClass root: self root) run! !

WAObject subclass: #WASessionContinuation
	instanceVariableNames: 'states'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WASessionContinuation commentStamp: 'lr 6/2/2008 09:19' prior: 0!
I represent a continuation as part of the flow of pages within a session. I am not a real continuation (as compared to those used in #call: and #answer:), I only represent a specific point in the session. I reference the root component and a memory snapshot of backtracked objects.!

WASessionContinuation subclass: #WARenderLoopContinuation
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

WARenderLoopContinuation subclass: #WAActionPhaseContinuation
	instanceVariableNames: 'renderingContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WAActionPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2008 15:50'!
handleRequest: aRequest 
	| renderContinuation |
	aRequest isXmlHttpRequest ifTrue: [ self requestContext onRespond: [ :r | states snapshot ] ].
	self withNotificationHandler: [ self renderingContext callbacks processWithRequest: aRequest ].
	
	renderContinuation := WARenderPhaseContinuation root: self root.	
	
	(self shouldRedirect: aRequest) 
		ifTrue: [ self respond: [ :response |
					renderContinuation setStates: self newStates.
					response redirectTo: renderContinuation url ] ]
		ifFalse: [ renderContinuation value: aRequest ]! !

!WAActionPhaseContinuation methodsFor: 'accessing' stamp: 'jf 9/28/2008 23:37'!
renderingContext
	^ renderingContext! !

!WAActionPhaseContinuation methodsFor: 'accessing' stamp: 'jf 9/28/2008 23:37'!
renderingContext: anObject 
	renderingContext := anObject! !

!WAActionPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2008 16:13'!
shouldRedirect: aRequest
	^ (aRequest isGet and: [ aRequest fields includesKey: '_n' ]) not! !

!WARenderLoopContinuation class methodsFor: 'instance-creation' stamp: 'jf 9/28/2008 23:02'!
root: aComponent
	^ self new initializeWithRoot: aComponent! !

!WARenderLoopContinuation methodsFor: 'initialization' stamp: 'jf 9/28/2008 23:02'!
initializeWithRoot: aComponent
	root := aComponent! !

!WARenderLoopContinuation methodsFor: 'creational' stamp: 'jf 9/28/2008 23:06'!
newRedirectContinuation
	"Answer a new redirect handler."

	^ (self application preferenceAt: #redirectContinuationClass) root: self root! !

!WARenderLoopContinuation methodsFor: 'creational' stamp: 'jf 9/28/2008 23:06'!
newRenderContinuation
	"Answer a new render continuation."

	^ (self application preferenceAt: #renderContinuationClass) root: self root! !

!WARenderLoopContinuation methodsFor: 'accessing' stamp: 'jf 9/28/2008 23:01'!
root
	"Answer the root component instance. Usually this component is instantiated with the first reuqest."

	^ root! !

!WARenderLoopContinuation methodsFor: 'updating' stamp: 'jf 9/28/2008 23:07'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	self root visiblePresentersDo: [ :each | each updateRoot: aHtmlRoot ]! !

!WARenderLoopContinuation methodsFor: 'updating' stamp: 'jf 9/28/2008 23:07'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	self root visiblePresentersDo: [ :each |
		(each isDecoration and: [ each isDelegation ])
			ifTrue: [ each component updateStates: aSnapshot ].
		each updateStates: aSnapshot ]! !

!WARenderLoopContinuation methodsFor: 'updating' stamp: 'jf 9/28/2008 23:06'!
updateUrl: anUrl
	super updateUrl: anUrl.
	self root visiblePresentersDo: [ :each | each updateUrl: anUrl ]! !

!WARenderLoopContinuation methodsFor: 'private' stamp: 'jf 9/28/2008 23:20'!
withNotificationHandler: aBlock
	^ aBlock on: WARenderNotification do: [ :n | ]! !

WARenderLoopContinuation subclass: #WARenderPhaseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 9/28/2008 23:24'!
handleRequest: aRequest 
	self withNotificationHandler: [ self render ]! !

!WARenderPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 10/16/2008 15:51'!
newContext
	| renderingContext actionContinuation |
	renderingContext := WARenderingContext new.
	actionContinuation := (WAActionPhaseContinuation root: self root) renderingContext: renderingContext.
	actionContinuation setStates: self newStates.
	renderingContext actionUrl: actionContinuation url.
	
	^ renderingContext! !

!WARenderPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 9/28/2008 23:32'!
newHtmlRootWithContext: aRenderContext
	| htmlRoot |
	htmlRoot := WAHtmlRoot context: aRenderContext.
	htmlRoot bodyAttributes at: 'onload' append: 'onLoad()' separator: ';'.
	self updateRoot: htmlRoot.
	^ htmlRoot! !

!WARenderPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 9/29/2008 01:19'!
processRendering: aResponse 
	| document htmlRoot renderingContext |
	renderingContext := self newContext.
	document := self application newDocumentOn: aResponse stream.
	renderingContext document: document.
	htmlRoot := self newHtmlRootWithContext: renderingContext.
	document open: htmlRoot.
	self root decorationChainDo: [ :each | each renderWithContext: renderingContext ].
	self writeOnLoadOn: document.
	document close: htmlRoot.
	renderingContext release! !

!WARenderPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 9/28/2008 23:28'!
render
	self session clearJumpTo.
	self respond: [ :response | self processRendering: response ]! !

!WARenderPhaseContinuation methodsFor: 'as yet unclassified' stamp: 'jf 9/28/2008 23:29'!
writeOnLoadOn: aDocument 
	| attributes |
	attributes := WAHtmlAttributes new.
	attributes 
		at: 'type'
		put: 'text/javascript'.
	aDocument 
		openTag: 'script'
		attributes: attributes
		closed: false.
	aDocument nextPutAll: '/*<!![CDATA[*/function onLoad(){'.
	self requestContext loadScripts 
		do: [ :each | aDocument nextPutAll: each seasideString ]
		separatedBy: [ aDocument nextPutAll: ';' ].
	aDocument nextPutAll: '}/*]]>*/'.
	aDocument closeTag: 'script'! !

!WASessionContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:34'!
handleRequest: aRequest
	self subclassResponsibility! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newResponse
	"Answer a new response object and assign the current request stream."

	| stream response |
	stream := self request responseStream.
	response := stream isNil
		ifTrue: [ WAResponse new ]
		ifFalse: [ WAStreamResponse on: stream ].
	^ response doNotCache! !

!WASessionContinuation methodsFor: 'creational' stamp: 'jf 10/16/2008 15:49'!
newStates
	| snapshot |
	snapshot := WASnapshot new.
	self requestContext onRespond: [ :value | self updateStates: snapshot ].
	^ snapshot! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:52'!
request
	"Answer the current request object."

	^ self requestContext request! !

!WASessionContinuation methodsFor: 'processing' stamp: 'jf 10/16/2008 15:51'!
respond: aBlock 
	| response context |
	response := self newResponse.
	context := self requestContext.
	context response: response.
	aBlock value: response.
	context returnResponse: response! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'jf 10/16/2008 15:32'!
setStates: aSnapshot
	states := aSnapshot! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 8/20/2007 22:59'!
states
	^ states! !

!WASessionContinuation methodsFor: 'updating' stamp: 'jf 9/28/2008 23:07'!
updateRoot: aHtmlRoot
	self session updateRoot: aHtmlRoot! !

!WASessionContinuation methodsFor: 'updating' stamp: 'jf 9/28/2008 23:07'!
updateStates: aSnapshot
	self session updateStates: aSnapshot! !

!WASessionContinuation methodsFor: 'updating' stamp: 'jf 9/28/2008 23:06'!
updateUrl: anUrl
	self session updateUrl: anUrl! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/17/2007 22:20'!
url
	| url |
	url := self session actionUrlForContinuation: self.
	self updateUrl: url.
	^ url! !

!WASessionContinuation methodsFor: 'evaluating' stamp: 'lr 5/31/2008 16:16'!
value: aRequest
	"Resume processing of aRequest. To ensure valid application state restore all registered states."

	states ifNotNil: [ states restore ].
	self handleRequest: aRequest! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopMain commentStamp: 'rew 10/19/2007 10:50' prior: 0!
When a new session on a WAApplication is started WARenderLoopMain initializes the application, that is it:
 
	creates the top level component of the application, 
	informs each component(WAPresenter) of the application that the session started (via WAPresenter>>initialRequest:)
	starts a WARenderLoop to handle the request
!

!WARenderLoopMain methodsFor: 'creational' stamp: 'lr 9/14/2008 13:14'!
createRoot
	^ self rootDecorationClasses
		inject: self rootClass new
		into: [ :component :decorationClass |
			component 
				addDecoration: decorationClass new;
				yourself ]! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'lr 9/14/2008 12:56'!
rootClass
	^ self application preferenceAt: #rootClass! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'lr 9/14/2008 13:03'!
rootDecorationClasses
	^ self application preferenceAt: #rootDecorationClasses! !

!WARenderLoopMain methodsFor: 'processing' stamp: 'jf 9/28/2008 23:39'!
start: aRequest
	| root |
	root := self createRoot.
	root visiblePresentersDo: [ :each | each initialRequest: aRequest ].
	(WARenderPhaseContinuation root: root) value: aRequest! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopConfiguration commentStamp: 'jf 7/22/2008 12:32' prior: 0!
WARenderLoopConfiguration defines attributes required by the Render Loop classes (see the Seaside-Core-RenderLoop category). Any application using these classes (e.g. WARenderLoopMain) should include this configuration (this is done by default for new applications).

See #addAttributes: for details on provided attributes.!

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'jf 10/16/2008 15:29'!
describeOn: config
	(config list: #rootClass)
		comment: 'The root component of this seaside application.';
		options: [self rootClasses].
	(config collection: #rootDecorationClasses)
		comment: 'The decoration clases that should wrap the root component.';
		options: [self rootDecorationClasses].
	config
		at: #mainClass put: WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:10'!
parents
	"We override several attributes of the session configuration."
	^ Array with: WASessionConfiguration instance! !

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 14:30'!
rootClasses
	^ (WAComponent allSubclasses select: [ :each | each canBeRoot ])
		asSortedCollection: [ :a :b | a name <= b name ]! !

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'lr 9/14/2008 12:58'!
rootDecorationClasses
	^ (WADecoration allSubclasses select: [ :each | each canBeRoot ])
		asSortedCollection: [ :a :b | a name <= b name ]! !
